// Thumbs		10000 `
#define ID_CHILD	1501
#define ID_TOOL		1502
#define ID_TREE		1503
#define ID_PAGER	1504

#define MYWNDCLASS	"CLASS_ECTIK"
#define MYWNDTITLE	"ECTIK"

HINSTANCE	g_hInst	= NULL;	// CX^Xnh
HWND		g_hDlg	= NULL;	// ݃ANeBuȃ_CAO
HMENU		g_hMenu	= NULL;

DWORD		g_dwCookie;
bool		flag_Accel = 1;

int 	TB_Bmp[] = {STD_FILEOPEN,STD_FILESAVE};	// c[o[{^̊G
int 	TB_Command[] = {IDM_OPEN,IDM_SAVE};		// c[o[{^̃j[ID
char	TB_Text[][30] = {"J","㏑ۑ"};	// c[o[{^̃eLXg

LRESULT	CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void	Set_Class(char *cls, WNDPROC ProcWnd);
HWND	Set_Child(HWND hWnd, char *cls, int wdh, int hgt, DWORD exStyle);
HWND	Set_Tool(HWND hWnd);
HWND	Set_Tree(HWND hWnd);
HWND	Set_Pager(HWND hParent, bool flag_Vert);
bool	Menu_Toggle_Check(HMENU hMenu, UINT ID);
void	Menu_Check(HMENU hMenu, UINT ID);
void	Menu_Uncheck(HMENU hMenu, UINT ID);
BOOL	TreeView_GetCheckState(HWND hwndTreeView, HTREEITEM hItem);
BOOL	TreeView_SetCheckState(HWND hwndTreeView, HTREEITEM hItem, BOOL fCheck);

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	// dNh~&R}hCn
	HWND hWnd = FindWindow(MYWNDCLASS, NULL);
	if(hWnd){
		SetForegroundWindow(hWnd);
		if(__argc > 1){
			COPYDATASTRUCT cds;
			ZeroMemory(&cds, sizeof(cds));
			cds.cbData = strlen(__argv[1])+1;
			cds.lpData = __argv[1];
			SendMessage(hWnd, WM_COPYDATA, NULL, (LPARAM)&cds);
		}
		return 0;
	}
	
	MSG 	   msg;
	WNDCLASSEX wc;
	
	g_hInst = hInst;
	
	// eEBhENX̓o^
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX);
	wc.lpfnWndProc		= (WNDPROC)ProcWnd;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON1));
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)(COLOR_BTNFACE + 1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	RegisterClassEx(&wc);
	
	g_hMenu = LoadMenu(hInst,MAKEINTRESOURCE(IDR_MENU1));
	
	// eEBhE̍쐬
	hWnd = CreateWindowEx(WS_EX_ACCEPTFILES,
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPEDWINDOW | WS_VISIBLE | WS_CLIPCHILDREN,
				CW_USEDEFAULT, CW_USEDEFAULT, 788, 535,
				NULL,
				g_hMenu,
				hInst,
				NULL);
	
	HACCEL hAC = LoadAccelerators( hInst, MAKEINTRESOURCE(IDR_ACCELERATOR1) );
	HtmlHelp(NULL, NULL, HH_INITIALIZE, g_dwCookie);
	
	while (GetMessage(&msg, NULL, 0, 0)) {
		if(flag_Accel && TranslateAccelerator(hWnd, hAC, &msg))
			continue;
		if(g_hDlg){
			if(IsDialogMessage(g_hDlg, &msg))	continue;
		}
		if(HtmlHelp(NULL, NULL, HH_PRETRANSLATEMESSAGE, (DWORD)&msg))
			continue;
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain

// EBhENX̓o^
void Set_Class(char *cls, WNDPROC ProcWnd)
{
	WNDCLASSEX wc;
	
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX);
	wc.lpfnWndProc		= (WNDPROC)ProcWnd;
	wc.hInstance		= GetModuleHandle(NULL);
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.style			= CS_DBLCLKS;
	wc.lpszClassName	= cls;
	RegisterClassEx(&wc);
	
}// Set_Class_Child

// qEBhE̍쐬
HWND Set_Child(HWND hWnd, char *cls, int wdh, int hgt, DWORD exStyle)
{
	HWND hChild = CreateWindowEx(
				exStyle,
				cls,
				NULL,
				WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN,
				0, 0, wdh, hgt,
				hWnd,
				(HMENU) ID_CHILD,
				GetModuleHandle(NULL),
				NULL);
	return (hChild);
}// Set_Child

// c[o[̍쐬
HWND Set_Tool(HWND hParent)
{
    HWND hTool = CreateWindowEx( 0,
                                 TOOLBARCLASSNAME,
                                 NULL,
                                 WS_CHILD | WS_VISIBLE | CCS_ADJUSTABLE | 
								 WS_CLIPCHILDREN | CCS_NORESIZE | CCS_NODIVIDER,
                                 0, 0, 0, 0,
                                 hParent,
                                 (HMENU) ID_TOOL,
                                 g_hInst,
                                 NULL);
    SendMessage(hTool,TB_BUTTONSTRUCTSIZE,sizeof(TBBUTTON),0);
    return (hTool);
}

// c[r[̍쐬
HWND Set_Tree(HWND hParent)
{
    HWND hTree = CreateWindowEx(
                WS_EX_CLIENTEDGE,
                WC_TREEVIEW,
                NULL,
                WS_CHILD | WS_VISIBLE | TVS_HASLINES | TVS_HASBUTTONS | 
                TVS_LINESATROOT | TVS_EDITLABELS | TVS_SHOWSELALWAYS | TVS_CHECKBOXES,
                0, 0, 0, 0,
                hParent,
                (HMENU) ID_TREE,
                g_hInst,
                NULL);
	return (hTree);
}// Set_Tree

// y[W[̍쐬
// flag_VertFc^  1A^  0
HWND Set_Pager(HWND hParent, bool flag_Vert)
{
	UINT style;
	if(flag_Vert){
		style = PGS_VERT;
	}
	else{
		style = PGS_HORZ;
	}
	HWND hPager =   CreateWindowEx(0,
								WC_PAGESCROLLER,
								NULL,
								WS_CHILD |
								WS_VISIBLE |
								WS_CLIPCHILDREN |
								CCS_NODIVIDER | 
								style,
								0, 0, 0, 0,
								hParent,
								(HMENU) ID_PAGER,
								g_hInst,
								NULL);
	return (hPager);
}// Set_Pager

// j[̃`FbNύX
bool Menu_Toggle_Check(HMENU hMenu, UINT ID)
{
	MENUITEMINFO    mi;
	
	ZeroMemory (&mi, sizeof(mi));
	mi.cbSize = sizeof(mi);
	mi.fMask = MIIM_STATE;
	
	GetMenuItemInfo(hMenu,ID,0,&mi);
	
	if(mi.fState == MFS_UNCHECKED)
		mi.fState = MFS_CHECKED;
	else
		mi.fState = MFS_UNCHECKED;
	
	SetMenuItemInfo(hMenu,ID,0,&mi);

	if(mi.fState == MFS_UNCHECKED)
		return 0;
	return 1;
}// Menu_Toggle_Check

// j[ACe`FbN
void Menu_Check(HMENU hMenu, UINT ID)
{
	MENUITEMINFO    mi;
	ZeroMemory (&mi, sizeof(mi));
	mi.cbSize = sizeof(mi);
	mi.fMask = MIIM_STATE;
	mi.fState = MFS_CHECKED;
	
	SetMenuItemInfo(hMenu,ID,0,&mi);
}// Menu_Check

// j[ACẽ`FbNO
void Menu_Uncheck(HMENU hMenu, UINT ID)
{
	MENUITEMINFO    mi;
	ZeroMemory (&mi, sizeof(mi));
	mi.cbSize = sizeof(mi);
	mi.fMask = MIIM_STATE;
	mi.fState = MFS_UNCHECKED;
	
	SetMenuItemInfo(hMenu,ID,0,&mi);
}// Menu_Uncheck

// c[r[ACẽ`FbNmF
BOOL TreeView_GetCheckState(HWND hwndTreeView, HTREEITEM hItem)
{
	TVITEM tvItem;
	
	tvItem.mask = TVIF_HANDLE | TVIF_STATE;
	tvItem.hItem = hItem;
	tvItem.stateMask = TVIS_STATEIMAGEMASK;
	TreeView_GetItem(hwndTreeView, &tvItem);
	return ((BOOL)(tvItem.state >> 12) -1);
}// TreeView_GetCheckState

// c[r[ACeɃ`FbN
BOOL TreeView_SetCheckState(HWND hwndTreeView, HTREEITEM hItem, BOOL fCheck)
{
	TVITEM tvItem;
	
	tvItem.mask = TVIF_HANDLE | TVIF_STATE;
	tvItem.hItem = hItem;
	tvItem.stateMask = TVIS_STATEIMAGEMASK;
	tvItem.state = INDEXTOSTATEIMAGEMASK((fCheck ? 2 : 1));
	return TreeView_SetItem(hwndTreeView, &tvItem);
}// TreeView_SetCheckState
